!-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for GLUT software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------

module f90glut

use f90gl_kinds

! Constants

integer(f90glcuint), parameter :: GLUT_RGB = 0
integer(f90glcuint), parameter :: GLUT_RGBA = 0
integer(f90glcuint), parameter :: GLUT_INDEX = 1
integer(f90glcuint), parameter :: GLUT_SINGLE = 0
integer(f90glcuint), parameter :: GLUT_DOUBLE = 2
integer(f90glcuint), parameter :: GLUT_ACCUM = 4
integer(f90glcuint), parameter :: GLUT_ALPHA = 8
integer(f90glcuint), parameter :: GLUT_DEPTH = 16
integer(f90glcuint), parameter :: GLUT_STENCIL = 32
integer(f90glcuint), parameter :: GLUT_MULTISAMPLE = 128
integer(f90glcuint), parameter :: GLUT_STEREO = 256
integer(f90glcint), parameter :: GLUT_LEFT_BUTTON = 0
integer(f90glcint), parameter :: GLUT_MIDDLE_BUTTON = 1
integer(f90glcint), parameter :: GLUT_RIGHT_BUTTON = 2
integer(f90glcint), parameter :: GLUT_DOWN = 0
integer(f90glcint), parameter :: GLUT_UP = 1
integer(f90glcint), parameter :: GLUT_KEY_F1 = 1
integer(f90glcint), parameter :: GLUT_KEY_F2 = 2
integer(f90glcint), parameter :: GLUT_KEY_F3 = 3
integer(f90glcint), parameter :: GLUT_KEY_F4 = 4
integer(f90glcint), parameter :: GLUT_KEY_F5 = 5
integer(f90glcint), parameter :: GLUT_KEY_F6 = 6
integer(f90glcint), parameter :: GLUT_KEY_F7 = 7
integer(f90glcint), parameter :: GLUT_KEY_F8 = 8
integer(f90glcint), parameter :: GLUT_KEY_F9 = 9
integer(f90glcint), parameter :: GLUT_KEY_F10 = 10
integer(f90glcint), parameter :: GLUT_KEY_F11 = 11
integer(f90glcint), parameter :: GLUT_KEY_F12 = 12
integer(f90glcint), parameter :: GLUT_KEY_LEFT = 100
integer(f90glcint), parameter :: GLUT_KEY_UP = 101
integer(f90glcint), parameter :: GLUT_KEY_RIGHT = 102
integer(f90glcint), parameter :: GLUT_KEY_DOWN = 103
integer(f90glcint), parameter :: GLUT_KEY_PAGE_UP = 104
integer(f90glcint), parameter :: GLUT_KEY_PAGE_DOWN = 105
integer(f90glcint), parameter :: GLUT_KEY_HOME = 106
integer(f90glcint), parameter :: GLUT_KEY_END = 107
integer(f90glcint), parameter :: GLUT_KEY_INSERT = 108
integer(f90glcint), parameter :: GLUT_LEFT = 0
integer(f90glcint), parameter :: GLUT_ENTERED = 1
integer(f90glcint), parameter :: GLUT_MENU_NOT_IN_USE = 0
integer(f90glcint), parameter :: GLUT_MENU_IN_USE = 1
integer(f90glcint), parameter :: GLUT_NOT_VISIBLE = 0
integer(f90glcint), parameter :: GLUT_VISIBLE = 1
integer(f90glcint), parameter :: GLUT_RED = 0
integer(f90glcint), parameter :: GLUT_GREEN = 1
integer(f90glcint), parameter :: GLUT_BLUE = 2
integer(f90glenum), parameter :: GLUT_WINDOW_X = 100
integer(f90glenum), parameter :: GLUT_WINDOW_Y = 101
integer(f90glenum), parameter :: GLUT_WINDOW_WIDTH = 102
integer(f90glenum), parameter :: GLUT_WINDOW_HEIGHT = 103
integer(f90glenum), parameter :: GLUT_WINDOW_BUFFER_SIZE = 104
integer(f90glenum), parameter :: GLUT_WINDOW_STENCIL_SIZE = 105
integer(f90glenum), parameter :: GLUT_WINDOW_DEPTH_SIZE = 106
integer(f90glenum), parameter :: GLUT_WINDOW_RED_SIZE = 107
integer(f90glenum), parameter :: GLUT_WINDOW_GREEN_SIZE = 108
integer(f90glenum), parameter :: GLUT_WINDOW_BLUE_SIZE = 109
integer(f90glenum), parameter :: GLUT_WINDOW_ALPHA_SIZE = 110
integer(f90glenum), parameter :: GLUT_WINDOW_ACCUM_RED_SIZE = 111
integer(f90glenum), parameter :: GLUT_WINDOW_ACCUM_GREEN_SIZE = 112
integer(f90glenum), parameter :: GLUT_WINDOW_ACCUM_BLUE_SIZE = 113
integer(f90glenum), parameter :: GLUT_WINDOW_ACCUM_ALPHA_SIZE = 114
integer(f90glenum), parameter :: GLUT_WINDOW_DOUBLEBUFFER = 115
integer(f90glenum), parameter :: GLUT_WINDOW_RGBA = 116
integer(f90glenum), parameter :: GLUT_WINDOW_PARENT = 117
integer(f90glenum), parameter :: GLUT_WINDOW_NUM_CHILDREN = 118
integer(f90glenum), parameter :: GLUT_WINDOW_COLORMAP_SIZE = 119
integer(f90glenum), parameter :: GLUT_WINDOW_NUM_SAMPLES = 120
integer(f90glenum), parameter :: GLUT_WINDOW_STEREO = 121
integer(f90glenum), parameter :: GLUT_WINDOW_CURSOR = 122
integer(f90glenum), parameter :: GLUT_SCREEN_WIDTH = 200
integer(f90glenum), parameter :: GLUT_SCREEN_HEIGHT = 201
integer(f90glenum), parameter :: GLUT_SCREEN_WIDTH_MM = 202
integer(f90glenum), parameter :: GLUT_SCREEN_HEIGHT_MM = 203
integer(f90glenum), parameter :: GLUT_MENU_NUM_ITEMS = 300
integer(f90glenum), parameter :: GLUT_DISPLAY_MODE_POSSIBLE = 400
integer(f90glenum), parameter :: GLUT_INIT_WINDOW_X = 500
integer(f90glenum), parameter :: GLUT_INIT_WINDOW_Y = 501
integer(f90glenum), parameter :: GLUT_INIT_WINDOW_WIDTH = 502
integer(f90glenum), parameter :: GLUT_INIT_WINDOW_HEIGHT = 503
integer(f90glenum), parameter :: GLUT_INIT_DISPLAY_MODE = 504
integer(f90glenum), parameter :: GLUT_ELAPSED_TIME = 700
integer(f90glenum), parameter :: GLUT_HAS_KEYBOARD = 600
integer(f90glenum), parameter :: GLUT_HAS_MOUSE = 601
integer(f90glenum), parameter :: GLUT_HAS_SPACEBALL = 602
integer(f90glenum), parameter :: GLUT_HAS_DIAL_AND_BUTTON_BOX = 603
integer(f90glenum), parameter :: GLUT_HAS_TABLET = 604
integer(f90glenum), parameter :: GLUT_NUM_MOUSE_BUTTONS = 605
integer(f90glenum), parameter :: GLUT_NUM_SPACEBALL_BUTTONS = 606
integer(f90glenum), parameter :: GLUT_NUM_BUTTON_BOX_BUTTONS = 607
integer(f90glenum), parameter :: GLUT_NUM_DIALS = 608
integer(f90glenum), parameter :: GLUT_NUM_TABLET_BUTTONS = 609
integer(f90glenum), parameter :: GLUT_OVERLAY_POSSIBLE = 800
integer(f90glenum), parameter :: GLUT_LAYER_IN_USE = 801
integer(f90glenum), parameter :: GLUT_HAS_OVERLAY = 802
integer(f90glenum), parameter :: GLUT_TRANSPARENT_INDEX = 803
integer(f90glenum), parameter :: GLUT_NORMAL_DAMAGED = 804
integer(f90glenum), parameter :: GLUT_OVERLAY_DAMAGED = 805
integer(f90glenum), parameter :: GLUT_NORMAL = 0
integer(f90glenum), parameter :: GLUT_OVERLAY = 1
integer(f90glcint), parameter :: GLUT_ACTIVE_SHIFT = 1
integer(f90glcint), parameter :: GLUT_ACTIVE_CTRL = 2
integer(f90glcint), parameter :: GLUT_ACTIVE_ALT = 4
integer(f90glcint), parameter :: GLUT_CURSOR_RIGHT_ARROW = 0
integer(f90glcint), parameter :: GLUT_CURSOR_LEFT_ARROW = 1
integer(f90glcint), parameter :: GLUT_CURSOR_INFO = 2
integer(f90glcint), parameter :: GLUT_CURSOR_DESTROY = 3
integer(f90glcint), parameter :: GLUT_CURSOR_HELP = 4
integer(f90glcint), parameter :: GLUT_CURSOR_CYCLE = 5
integer(f90glcint), parameter :: GLUT_CURSOR_SPRAY = 6
integer(f90glcint), parameter :: GLUT_CURSOR_WAIT = 7
integer(f90glcint), parameter :: GLUT_CURSOR_TEXT = 8
integer(f90glcint), parameter :: GLUT_CURSOR_CROSSHAIR = 9
integer(f90glcint), parameter :: GLUT_CURSOR_UP_DOWN = 10
integer(f90glcint), parameter :: GLUT_CURSOR_LEFT_RIGHT = 11
integer(f90glcint), parameter :: GLUT_CURSOR_TOP_SIDE = 12
integer(f90glcint), parameter :: GLUT_CURSOR_BOTTOM_SIDE = 13
integer(f90glcint), parameter :: GLUT_CURSOR_LEFT_SIDE = 14
integer(f90glcint), parameter :: GLUT_CURSOR_RIGHT_SIDE = 15
integer(f90glcint), parameter :: GLUT_CURSOR_TOP_LEFT_CORNER = 16
integer(f90glcint), parameter :: GLUT_CURSOR_TOP_RIGHT_CORNER = 17
integer(f90glcint), parameter :: GLUT_CURSOR_BOTTOM_RIGHT_CORNER = 18
integer(f90glcint), parameter :: GLUT_CURSOR_BOTTOM_LEFT_CORNER = 19
integer(f90glcint), parameter :: GLUT_CURSOR_INHERIT = 100
integer(f90glcint), parameter :: GLUT_CURSOR_NONE = 101
integer(f90glcint), parameter :: GLUT_CURSOR_FULL_CROSSHAIR = 102

! interface blocks

interface f90glutinitdisplaymode         
   subroutine glutinitdisplaymode(mode)
   use f90gl_kinds
   integer(f90glcuint) mode
   end subroutine
end interface

interface f90glutinitwindowposition      
   subroutine glutinitwindowposition(x,y)
   use f90gl_kinds
   integer(f90glcint) x, y
   end subroutine
end interface

interface f90glutinitwindowsize          
   subroutine glutinitwindowsize(width,height)
   use f90gl_kinds
   integer(f90glcint) width, height
   end subroutine
end interface

interface f90glutmainloop                
   subroutine glutmainloop()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutcreatewindow            
   module procedure f9xglutcreatewindow
end interface

interface f90glutcreatesubwindow         
   function glutcreatesubwindow(win,x,y,width,height)
   use f90gl_kinds
   integer(f90glcint) glutcreatesubwindow
   integer(f90glcint) win, x, y, width, height
   end function
end interface

interface f90glutdestroywindow           
   subroutine glutdestroywindow(win)
   use f90gl_kinds
   integer(f90glcint) win
   end subroutine
end interface

interface f90glutpostredisplay           
   subroutine glutpostredisplay()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutswapbuffers             
   subroutine glutswapbuffers()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutgetwindow               
   function glutgetwindow()
   use f90gl_kinds
   integer(f90glcint) glutgetwindow
   end function
end interface

interface f90glutsetwindow               
   subroutine glutsetwindow(win)
   use f90gl_kinds
   integer(f90glcint) win
   end subroutine
end interface

interface f90glutsetwindowtitle          
   module procedure f9xglutsetwindowtitle
end interface

interface f90glutseticontitle            
   module procedure f9xglutseticontitle
end interface

interface f90glutpositionwindow          
   subroutine glutpositionwindow(x,y)
   use f90gl_kinds
   integer(f90glcint) x, y
   end subroutine
end interface

interface f90glutreshapewindow           
   subroutine glutreshapewindow(width,height)
   use f90gl_kinds
   integer(f90glcint) width, height
   end subroutine
end interface

interface f90glutpopwindow               
   subroutine glutpopwindow()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutpushwindow              
   subroutine glutpushwindow()
   use f90gl_kinds
   end subroutine
end interface

interface f90gluticonifywindow           
   subroutine gluticonifywindow()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutshowwindow              
   subroutine glutshowwindow()
   use f90gl_kinds
   end subroutine
end interface

interface f90gluthidewindow              
   subroutine gluthidewindow()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutfullscreen              
   subroutine glutfullscreen()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutsetcursor               
   subroutine glutsetcursor(cursor)
   use f90gl_kinds
   integer(f90glcint) cursor
   end subroutine
end interface

interface f90glutestablishoverlay        
   subroutine glutestablishoverlay()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutremoveoverlay           
   subroutine glutremoveoverlay()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutuselayer                
   subroutine glutuselayer(layer)
   use f90gl_kinds
   integer(f90glenum) layer
   end subroutine
end interface

interface f90glutpostoverlayredisplay    
   subroutine glutpostoverlayredisplay()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutshowoverlay             
   subroutine glutshowoverlay()
   use f90gl_kinds
   end subroutine
end interface

interface f90gluthideoverlay             
   subroutine gluthideoverlay()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutdestroymenu             
   subroutine glutdestroymenu(menu)
   use f90gl_kinds
   integer(f90glcint) menu
   end subroutine
end interface

interface f90glutgetmenu                 
   function glutgetmenu()
   use f90gl_kinds
   integer(f90glcint) glutgetmenu
   end function
end interface

interface f90glutsetmenu                 
   subroutine glutsetmenu(menu)
   use f90gl_kinds
   integer(f90glcint) menu
   end subroutine
end interface

interface f90glutaddmenuentry            
   module procedure f9xglutaddmenuentry
end interface

interface f90glutaddsubmenu              
   module procedure f9xglutaddsubmenu
end interface

interface f90glutchangetomenuentry       
   module procedure f9xglutchangetomenuentry
end interface

interface f90glutchangetosubmenu         
   module procedure f9xglutchangetosubmenu
end interface

interface f90glutremovemenuitem          
   subroutine glutremovemenuitem(item)
   use f90gl_kinds
   integer(f90glcint) item
   end subroutine
end interface

interface f90glutattachmenu              
   subroutine glutattachmenu(button)
   use f90gl_kinds
   integer(f90glcint) button
   end subroutine
end interface

interface f90glutdetachmenu              
   subroutine glutdetachmenu(button)
   use f90gl_kinds
   integer(f90glcint) button
   end subroutine
end interface

interface f90glutsetcolor                
   subroutine glutsetcolor(ndx,red,green,blue)
   use f90gl_kinds
   integer(f90glcint) ndx
   real(f90glfloat) red, green, blue
   end subroutine
end interface

interface f90glutgetcolor                
   function glutgetcolor(ndx,component)
   use f90gl_kinds
   real(f90glfloat) glutgetcolor
   integer(f90glcint) ndx, component
   end function
end interface

interface f90glutcopycolormap            
   subroutine glutcopycolormap(win)
   use f90gl_kinds
   integer(f90glcint) win
   end subroutine
end interface

interface f90glutget                     
   function glutget(type)
   use f90gl_kinds
   integer(f90glcint) glutget
   integer(f90glenum) type
   end function
end interface

interface f90glutdeviceget               
   function glutdeviceget(type)
   use f90gl_kinds
   integer(f90glcint) glutdeviceget
   integer(f90glenum) type
   end function
end interface

interface f90glutextensionsupported      
   module procedure f9xglutextensionsupported
end interface

interface f90glutgetmodifiers            
   function glutgetmodifiers()
   use f90gl_kinds
   integer(f90glcint) glutgetmodifiers
   end function
end interface

interface f90glutlayerget                
   function glutlayerget(type)
   use f90gl_kinds
   integer(f90glcint) glutlayerget
   integer(f90glenum) type
   end function
end interface

interface f90glutbitmapwidth             
   function glutbitmapwidth(font,character)
   use f90gl_kinds
   integer(f90glcint) glutbitmapwidth
   external font
   integer(f90glcint) character
   end function
end interface

interface f90glutstrokewidth             
   function glutstrokewidth(font,character)
   use f90gl_kinds
   integer(f90glcint) glutstrokewidth
   external font
   integer(f90glcint) character
   end function
end interface

interface f90glutwiresphere              
   subroutine glutwiresphere(radius,slices,stacks)
   use f90gl_kinds
   real(f90gldouble) radius
   integer(f90glint) slices, stacks
   end subroutine
end interface

interface f90glutsolidsphere             
   subroutine glutsolidsphere(radius,slices,stacks)
   use f90gl_kinds
   real(f90gldouble) radius
   integer(f90glint) slices, stacks
   end subroutine
end interface

interface f90glutwirecone                
   subroutine glutwirecone(base,height,slices,stacks)
   use f90gl_kinds
   real(f90gldouble) base, height
   integer(f90glint) slices, stacks
   end subroutine
end interface

interface f90glutsolidcone               
   subroutine glutsolidcone(base,height,slices,stacks)
   use f90gl_kinds
   real(f90gldouble) base, height
   integer(f90glint) slices, stacks
   end subroutine
end interface

interface f90glutwirecube                
   subroutine glutwirecube(size)
   use f90gl_kinds
   real(f90gldouble) size
   end subroutine
end interface

interface f90glutsolidcube               
   subroutine glutsolidcube(size)
   use f90gl_kinds
   real(f90gldouble) size
   end subroutine
end interface

interface f90glutwiretorus               
   subroutine glutwiretorus(innerradius,outerradius,sides,rings)
   use f90gl_kinds
   real(f90gldouble) innerradius, outerradius
   integer(f90glint) sides, rings
   end subroutine
end interface

interface f90glutsolidtorus              
   subroutine glutsolidtorus(innerradius,outerradius,sides,rings)
   use f90gl_kinds
   real(f90gldouble) innerradius, outerradius
   integer(f90glint) sides, rings
   end subroutine
end interface

interface f90glutwiredodecahedron        
   subroutine glutwiredodecahedron()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutsoliddodecahedron       
   subroutine glutsoliddodecahedron()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutwireteapot              
   subroutine glutwireteapot(size)
   use f90gl_kinds
   real(f90gldouble) size
   end subroutine
end interface

interface f90glutsolidteapot             
   subroutine glutsolidteapot(size)
   use f90gl_kinds
   real(f90gldouble) size
   end subroutine
end interface

interface f90glutwireoctahedron          
   subroutine glutwireoctahedron()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutsolidoctahedron         
   subroutine glutsolidoctahedron()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutwiretetrahedron         
   subroutine glutwiretetrahedron()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutsolidtetrahedron        
   subroutine glutsolidtetrahedron()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutwireicosahedron         
   subroutine glutwireicosahedron()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutsolidicosahedron        
   subroutine glutsolidicosahedron()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutmenustatusfunc
   subroutine glutmenustatusfunc(menustatusfunc)
   use f90gl_kinds
   interface
      subroutine menustatusfunc(status,x,y)
      use f90gl_kinds
      integer(f90glcint) status,x,y
      end subroutine menustatusfunc
   end interface
   end subroutine
end interface

interface f90glutoverlaydisplayfunc
   subroutine glutoverlaydisplayfunc(display)
   use f90gl_kinds
   interface
      subroutine display
      end subroutine display
   end interface
   end subroutine
end interface

interface f90glutinit
   subroutine glutinit()
   use f90gl_kinds
   end subroutine
end interface

interface f90glutreshapefunc
   subroutine glutreshapefunc(reshapefunc)
   use f90gl_kinds
   interface
      subroutine reshapefunc(width, height)
      use f90gl_kinds
      integer(f90glcint) width, height
      end subroutine reshapefunc
   end interface
   end subroutine
end interface

interface f90glutkeyboardfunc
   subroutine glutkeyboardfunc(keyboardfunc)
   use f90gl_kinds
   interface
      subroutine keyboardfunc(ch,x,y)
      use f90gl_kinds
      integer(f90glcint) ch,x,y
      end subroutine keyboardfunc
   end interface
   end subroutine
end interface

interface f90glutmousefunc
   subroutine glutmousefunc(mousefunc)
   use f90gl_kinds
   interface
      subroutine mousefunc(button,state,x,y)
      use f90gl_kinds
      integer(f90glcint) button,state,x,y
      end subroutine mousefunc
   end interface
   end subroutine
end interface

interface f90glutmotionfunc
   subroutine glutmotionfunc(motionfunc)
   use f90gl_kinds
   interface
      subroutine motionfunc(x,y)
      use f90gl_kinds
      integer(f90glcint) x,y
      end subroutine motionfunc
   end interface
   end subroutine
end interface

interface f90glutentryfunc
   subroutine glutentryfunc(entryfunc)
   use f90gl_kinds
   interface
      subroutine entryfunc(state)
      use f90gl_kinds
      integer(f90glcint) state
      end subroutine entryfunc
   end interface
   end subroutine
end interface

interface f90glutvisibilityfunc
   subroutine glutvisibilityfunc(visibilityfunc)
   use f90gl_kinds
   interface
      subroutine visibilityfunc(state)
      use f90gl_kinds
      integer(f90glcint) state
      end subroutine visibilityfunc
   end interface
   end subroutine
end interface

interface f90glutspecialfunc
   subroutine glutspecialfunc(specialfunc)
   use f90gl_kinds
   interface
      subroutine specialfunc(key,x,y)
      use f90gl_kinds
      integer(f90glcint) key,x,y
      end subroutine specialfunc
   end interface
   end subroutine
end interface

interface f90glutdialsfunc
   subroutine glutdialsfunc(dialsfunc)
   use f90gl_kinds
   interface
      subroutine dialsfunc(dial,value)
      use f90gl_kinds
      integer(f90glcint) dial,value
      end subroutine dialsfunc
   end interface
   end subroutine
end interface

interface f90glutdisplayfunc
   subroutine glutdisplayfunc(display)
   use f90gl_kinds
   interface
      subroutine display
      end subroutine display
   end interface
   end subroutine
end interface

interface f90glutpassivemotionfunc
   subroutine glutpassivemotionfunc(passive)
   use f90gl_kinds
   interface
      subroutine passive(x,y)
      use f90gl_kinds
      integer(f90glcint) x,y
      end subroutine passive
   end interface
   end subroutine
end interface

interface f90glutspacemotionfunc
   subroutine glutspacemotionfunc(spacemotion)
   use f90gl_kinds
   interface
      subroutine spacemotion(x,y,z)
      use f90gl_kinds
      integer(f90glcint) x,y,z
      end subroutine spacemotion
   end interface
   end subroutine
end interface

interface f90glutspacerotatefunc
   subroutine glutspacerotatefunc(spacerotate)
   use f90gl_kinds
   interface
      subroutine spacerotate(x,y,z) 
      use f90gl_kinds
      integer(f90glcint) x,y,z 
      end subroutine spacerotate 
   end interface
   end subroutine
end interface

interface f90glutspacebuttonfunc
   subroutine glutspacebuttonfunc(spacebutton)
   use f90gl_kinds
   interface
      subroutine spacebutton(button,state)
      use f90gl_kinds
      integer(f90glcint) button,state
      end subroutine spacebutton
   end interface
   end subroutine
end interface

interface f90glutbuttonboxfunc
   subroutine glutbuttonboxfunc(buttonbox)
   use f90gl_kinds
   interface
      subroutine buttonbox(button,state)
      use f90gl_kinds
      integer(f90glcint) button,state
      end subroutine buttonbox
   end interface
   end subroutine
end interface

interface f90gluttabletmotionfunc
   subroutine gluttabletmotionfunc(tabletmotion)
   use f90gl_kinds
   interface
      subroutine tabletmotion(x,y)
      use f90gl_kinds
      integer(f90glcint) x,y
      end subroutine tabletmotion
   end interface
   end subroutine
end interface

interface f90gluttabletbuttonfunc
   subroutine gluttabletbuttonfunc(tabletbutton)
   use f90gl_kinds
   interface
      subroutine tabletbutton(button,state,x,y)
      use f90gl_kinds
      integer(f90glcint) button,state,x,y
      end subroutine tabletbutton
   end interface
   end subroutine
end interface

interface f90glutcreatemenu
   function glutcreatemenu(selectfunc)
   use f90gl_kinds
   integer(f90glcint) glutcreatemenu
   interface
      subroutine selectfunc(value)
      use f90gl_kinds
      integer(f90glcint) value
      end subroutine selectfunc
   end interface
   end function
end interface

interface f90gluttimerfunc
   subroutine gluttimerfunc(interval, timerfunc, value)
   use f90gl_kinds
   integer(f90glculong) interval
   interface
      subroutine timerfunc(value)
      use f90gl_kinds
      integer(f90glcint) value
      end subroutine timerfunc
   end interface
   integer(f90glcint) value
   end subroutine
end interface

interface f90glutidlefunc
   subroutine glutidlefunc(idlefunc)
   use f90gl_kinds
   interface
      subroutine idlefunc
      end subroutine idlefunc
   end interface
   end subroutine
end interface

interface f90glutmenustatefunc
   subroutine glutmenustatefunc(menustatefunc)
   use f90gl_kinds
   interface
      subroutine menustatefunc(value)
      use f90gl_kinds
      integer(f90glcint) value
      end subroutine menustatefunc
   end interface
   end subroutine
end interface

interface f90glutbitmapcharacter
   subroutine glutbitmapcharacter(font, ch)
   use f90gl_kinds
   external font
   integer(f90glcint) ch
   end subroutine
end interface

interface f90glutstrokecharacter
   subroutine glutstrokecharacter(font, ch)
   use f90gl_kinds
   external font
   integer(f90glcint) ch
   end subroutine
end interface

contains

! fortran 90 wrappers for procedures that might have the wrong KIND of argument

function f9xglutcreatewindow(title)
integer(f90glcint) f9xglutcreatewindow
integer(f90glcint), external :: f9yglutcreatewindow
character(len=*) title
integer(f90gluint) int_title(len_trim(title))
integer i
int_title = (/ (ichar(title(i:i)),i=1,len_trim(title)) /)
f9xglutcreatewindow = f9yglutcreatewindow(int_title,len_trim(title))
end function f9xglutcreatewindow

subroutine f9xglutsetwindowtitle(title)
character(len=*) title
integer(f90gluint) int_title(len_trim(title))
integer i
int_title = (/ (ichar(title(i:i)),i=1,len_trim(title)) /)
call f9yglutsetwindowtitle(int_title,len_trim(title))
end subroutine f9xglutsetwindowtitle

subroutine f9xglutseticontitle(title)
character(len=*) title
integer(f90gluint) int_title(len_trim(title))
integer i
int_title = (/ (ichar(title(i:i)),i=1,len_trim(title)) /)
call f9yglutseticontitle(int_title,len_trim(title))
end subroutine f9xglutseticontitle

subroutine f9xglutaddmenuentry(label,value)
character(len=*) label
integer(f90glcint) value
integer(f90gluint) int_label(len_trim(label))
integer i
int_label = (/ (ichar(label(i:i)),i=1,len_trim(label)) /)
call f9yglutaddmenuentry(int_label,len_trim(label),value)
end subroutine f9xglutaddmenuentry

subroutine f9xglutaddsubmenu(label,submenu)
character(len=*) label
integer(f90glcint) submenu
integer(f90gluint) int_label(len_trim(label))
integer i
int_label = (/ (ichar(label(i:i)),i=1,len_trim(label)) /)
call f9yglutaddsubmenu(int_label,len_trim(label),submenu)
end subroutine f9xglutaddsubmenu

subroutine f9xglutchangetomenuentry(item,label,value)
integer(f90glcint) item
character(len=*) label
integer(f90glcint) value
integer(f90gluint) int_label(len_trim(label))
integer i
int_label = (/ (ichar(label(i:i)),i=1,len_trim(label)) /)
call f9yglutchangetomenuentry(item,int_label,len_trim(label),value)
end subroutine f9xglutchangetomenuentry

subroutine f9xglutchangetosubmenu(item,label,submenu)
integer(f90glcint) item
character(len=*) label
integer(f90glcint) submenu
integer(f90gluint) int_label(len_trim(label))
integer i
int_label = (/ (ichar(label(i:i)),i=1,len_trim(label)) /)
call f9yglutchangetosubmenu(item,int_label,len_trim(label),submenu)
end subroutine f9xglutchangetosubmenu

function f9xglutextensionsupported(name)
integer(f90glcint) f9xglutextensionsupported
integer(f90glcint), external :: f9yglutextensionsupported
character(len=*) name
integer(f90gluint) int_name(len_trim(name))
integer i
int_name = (/ (ichar(name(i:i)),i=1,len_trim(name)) /)
f9xglutextensionsupported = f9yglutextensionsupported(int_name,len_trim(name))
end function f9xglutextensionsupported

end module f90glut
