!-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for Mesa software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------

module f90glu

use f90gl_kinds

! Define the types for GLU

type f90gluquadricobj 
   character(f90glcptr) :: addr(2)
end type f90gluquadricobj
 
type f90glunurbsobj
   character(f90glcptr) :: addr(2)
end type f90glunurbsobj

type f90glutriangulatorobj
   character(f90glcptr) :: addr(6)
end type f90glutriangulatorobj

! Constants

integer(f90glenum), parameter :: GLU_SMOOTH     = 100000
integer(f90glenum), parameter :: GLU_FLAT       = 100001
integer(f90glenum), parameter :: GLU_NONE       = 100002
integer(f90glenum), parameter :: GLU_POINT      = 100010
integer(f90glenum), parameter :: GLU_LINE       = 100011
integer(f90glenum), parameter :: GLU_FILL       = 100012
integer(f90glenum), parameter :: GLU_SILHOUETTE = 100013
integer(f90glenum), parameter :: GLU_OUTSIDE    = 100020
integer(f90glenum), parameter :: GLU_INSIDE     = 100021
integer(f90glenum), parameter :: GLU_BEGIN      = 100100
integer(f90glenum), parameter :: GLU_VERTEX     = 100101
integer(f90glenum), parameter :: GLU_END        = 100102
integer(f90glenum), parameter :: GLU_ERROR      = 100103
integer(f90glenum), parameter :: GLU_EDGE_FLAG  = 100104
integer(f90glenum), parameter :: GLU_CW         = 100120
integer(f90glenum), parameter :: GLU_CCW        = 100121
integer(f90glenum), parameter :: GLU_INTERIOR   = 100122
integer(f90glenum), parameter :: GLU_EXTERIOR   = 100123
integer(f90glenum), parameter :: GLU_UNKNOWN    = 100124
integer(f90glenum), parameter :: GLU_TESS_ERROR1 = 100151
integer(f90glenum), parameter :: GLU_TESS_ERROR2 = 100152
integer(f90glenum), parameter :: GLU_TESS_ERROR3 = 100153
integer(f90glenum), parameter :: GLU_TESS_ERROR4 = 100154
integer(f90glenum), parameter :: GLU_TESS_ERROR5 = 100155
integer(f90glenum), parameter :: GLU_TESS_ERROR6 = 100156
integer(f90glenum), parameter :: GLU_TESS_ERROR7 = 100157
integer(f90glenum), parameter :: GLU_TESS_ERROR8 = 100158
integer(f90glenum), parameter :: GLU_TESS_ERROR9 = 100159
integer(f90glenum), parameter :: GLU_AUTO_LOAD_MATRIX     = 100200
integer(f90glenum), parameter :: GLU_CULLING              = 100201
integer(f90glenum), parameter :: GLU_PARAMETRIC_TOLERANCE = 100202
integer(f90glenum), parameter :: GLU_SAMPLING_TOLERANCE   = 100203
integer(f90glenum), parameter :: GLU_DISPLAY_MODE         = 100204
integer(f90glenum), parameter :: GLU_SAMPLING_METHOD      = 100205
integer(f90glenum), parameter :: GLU_U_STEP               = 100206
integer(f90glenum), parameter :: GLU_V_STEP               = 100207
integer(f90glenum), parameter :: GLU_PATH_LENGTH      = 100215
integer(f90glenum), parameter :: GLU_PARAMETRIC_ERROR = 100216
integer(f90glenum), parameter :: GLU_DOMAIN_DISTANCE  = 100217
integer(f90glenum), parameter :: GLU_MAP1_TRIM_2      = 100210
integer(f90glenum), parameter :: GLU_MAP1_TRIM_3      = 100211
integer(f90glenum), parameter :: GLU_OUTLINE_POLYGON = 100240
integer(f90glenum), parameter :: GLU_OUTLINE_PATCH = 100241
integer(f90glenum), parameter :: GLU_NURBS_ERROR1  = 100251
integer(f90glenum), parameter :: GLU_NURBS_ERROR2  = 100252
integer(f90glenum), parameter :: GLU_NURBS_ERROR3  = 100253
integer(f90glenum), parameter :: GLU_NURBS_ERROR4  = 100254
integer(f90glenum), parameter :: GLU_NURBS_ERROR5  = 100255
integer(f90glenum), parameter :: GLU_NURBS_ERROR6  = 100256
integer(f90glenum), parameter :: GLU_NURBS_ERROR7  = 100257
integer(f90glenum), parameter :: GLU_NURBS_ERROR8  = 100258
integer(f90glenum), parameter :: GLU_NURBS_ERROR9  = 100259
integer(f90glenum), parameter :: GLU_NURBS_ERROR10 = 100260
integer(f90glenum), parameter :: GLU_NURBS_ERROR11 = 100261
integer(f90glenum), parameter :: GLU_NURBS_ERROR12 = 100262
integer(f90glenum), parameter :: GLU_NURBS_ERROR13 = 100263
integer(f90glenum), parameter :: GLU_NURBS_ERROR14 = 100264
integer(f90glenum), parameter :: GLU_NURBS_ERROR15 = 100265
integer(f90glenum), parameter :: GLU_NURBS_ERROR16 = 100266
integer(f90glenum), parameter :: GLU_NURBS_ERROR17 = 100267
integer(f90glenum), parameter :: GLU_NURBS_ERROR18 = 100268
integer(f90glenum), parameter :: GLU_NURBS_ERROR19 = 100269
integer(f90glenum), parameter :: GLU_NURBS_ERROR20 = 100270
integer(f90glenum), parameter :: GLU_NURBS_ERROR21 = 100271
integer(f90glenum), parameter :: GLU_NURBS_ERROR22 = 100272
integer(f90glenum), parameter :: GLU_NURBS_ERROR23 = 100273
integer(f90glenum), parameter :: GLU_NURBS_ERROR24 = 100274
integer(f90glenum), parameter :: GLU_NURBS_ERROR25 = 100275
integer(f90glenum), parameter :: GLU_NURBS_ERROR26 = 100276
integer(f90glenum), parameter :: GLU_NURBS_ERROR27 = 100277
integer(f90glenum), parameter :: GLU_NURBS_ERROR28 = 100278
integer(f90glenum), parameter :: GLU_NURBS_ERROR29 = 100279
integer(f90glenum), parameter :: GLU_NURBS_ERROR30 = 100280
integer(f90glenum), parameter :: GLU_NURBS_ERROR31 = 100281
integer(f90glenum), parameter :: GLU_NURBS_ERROR32 = 100282
integer(f90glenum), parameter :: GLU_NURBS_ERROR33 = 100283
integer(f90glenum), parameter :: GLU_NURBS_ERROR34 = 100284
integer(f90glenum), parameter :: GLU_NURBS_ERROR35 = 100285
integer(f90glenum), parameter :: GLU_NURBS_ERROR36 = 100286
integer(f90glenum), parameter :: GLU_NURBS_ERROR37 = 100287
integer(f90glenum), parameter :: GLU_INVALID_ENUM  = 100900
integer(f90glenum), parameter :: GLU_INVALID_VALUE = 100901
integer(f90glenum), parameter :: GLU_OUT_OF_MEMORY = 100902
integer(f90glenum), parameter :: GLU_INCOMPATIBLE_GL_VERSION = 100903
integer(f90glenum), parameter :: GLU_VERSION    = 100800
integer(f90glenum), parameter :: GLU_EXTENSIONS = 100801

! interface blocks

interface f90glulookat                   
   subroutine fglulookat(eyex,eyey,eyez,centerx,centery,centerz,upx,upy,upz)
   use f90gl_kinds
   real(f90gldouble) eyex, eyey, eyez, centerx, centery, centerz, upx, upy, &
    upz
   end subroutine
end interface

interface f90gluortho2d                  
   subroutine fgluortho2d(left,right,bottom,top)
   use f90gl_kinds
   real(f90gldouble) left, right, bottom, top
   end subroutine
end interface

interface f90gluperspective              
   subroutine fgluperspective(fovy,aspect,znear,zfar)
   use f90gl_kinds
   real(f90gldouble) fovy, aspect, znear, zfar
   end subroutine
end interface

interface f90glupickmatrix               
   subroutine fglupickmatrix(x,y,width,height,viewport)
   use f90gl_kinds
   real(f90gldouble) x, y, width, height
   integer(f90glint) viewport(*)
   end subroutine
end interface

interface f90gluproject                  
   function fgluproject(objx,objy,objz,modelmatrix,projmatrix,viewport,winx, &
   winy,winz)
   use f90gl_kinds
   integer(f90glint) fgluproject
   real(f90gldouble) objx, objy, objz, modelmatrix(*), projmatrix(*)
   integer(f90glint) viewport(*)
   real(f90gldouble) winx, winy, winz
   end function
end interface

interface f90gluunproject                
   function fgluunproject(winx,winy,winz,modelmatrix,projmatrix,viewport, &
   objx,objy,objz)
   use f90gl_kinds
   integer(f90glint) fgluunproject
   real(f90gldouble) winx, winy, winz, modelmatrix(*), projmatrix(*)
   integer(f90glint) viewport(*)
   real(f90gldouble) objx, objy, objz
   end function
end interface

interface f90gluerrorstring              
   module procedure f9xgluerrorstring
end interface

interface f90gluscaleimage               
   function f9y0gluscaleimage(format,widthin,heightin,typein,datain,widthout, &
   heightout,typeout,dataout)
   use f90gl_kinds
   integer(f90glint) f9y0gluscaleimage
   integer(f90glenum) format
   integer(f90glint) widthin, heightin
   integer(f90glenum) typein
   integer(f90glint) datain(*)
   integer(f90glint) widthout, heightout
   integer(f90glenum) typeout
   integer(f90glint) dataout(*)
   end function
   function f9y1gluscaleimage(format,widthin,heightin,typein,datain,widthout, &
   heightout,typeout,dataout)
   use f90gl_kinds
   integer(f90glint) f9y1gluscaleimage
   integer(f90glenum) format
   integer(f90glint) widthin, heightin
   integer(f90glenum) typein
   real(f90glfloat) datain(*)
   integer(f90glint) widthout, heightout
   integer(f90glenum) typeout
   real(f90glfloat) dataout(*)
   end function
   function f9y2gluscaleimage(format,widthin,heightin,typein,datain,widthout, &
   heightout,typeout,dataout)
   use f90gl_kinds
   integer(f90glint) f9y2gluscaleimage
   integer(f90glenum) format
   integer(f90glint) widthin, heightin
   integer(f90glenum) typein
   integer(f90glint) datain(*)
   integer(f90glint) widthout, heightout
   integer(f90glenum) typeout
   real(f90glfloat) dataout(*)
   end function
   function f9y3gluscaleimage(format,widthin,heightin,typein,datain,widthout, &
   heightout,typeout,dataout)
   use f90gl_kinds
   integer(f90glint) f9y3gluscaleimage
   integer(f90glenum) format
   integer(f90glint) widthin, heightin
   integer(f90glenum) typein
   real(f90glfloat) datain(*)
   integer(f90glint) widthout, heightout
   integer(f90glenum) typeout
   integer(f90glint) dataout(*)
   end function
   module procedure f9xgluscaleimage
end interface

interface f90glubuild1dmipmaps           
   function f9y0glubuild1dmipmaps(target,components,width,format,type,data)
   use f90gl_kinds
   integer(f90glint) f9y0glubuild1dmipmaps
   integer(f90glenum) target
   integer(f90glint) components, width
   integer(f90glenum) format, type
   integer(f90glint) data(*)
   end function
   function f9y1glubuild1dmipmaps(target,components,width,format,type,data)
   use f90gl_kinds
   integer(f90glint) f9y1glubuild1dmipmaps
   integer(f90glenum) target
   integer(f90glint) components, width
   integer(f90glenum) format, type
   real(f90glfloat) data(*)
   end function
   function f9y2glubuild1dmipmaps(target,components,width,format,type,data)
   use f90gl_kinds
   integer(f90glint) f9y2glubuild1dmipmaps
   integer(f90glenum) target
   integer(f90glint) components, width
   integer(f90glenum) format, type
   integer(f90glint) data
   end function
   function f9y3glubuild1dmipmaps(target,components,width,format,type,data)
   use f90gl_kinds
   integer(f90glint) f9y3glubuild1dmipmaps
   integer(f90glenum) target
   integer(f90glint) components, width
   integer(f90glenum) format, type
   real(f90glfloat) data
   end function
   module procedure f9xglubuild1dmipmaps
end interface

interface f90glubuild2dmipmaps           
   function f9y0glubuild2dmipmaps(target,components,width,height,format,type, &
   data)
   use f90gl_kinds
   integer(f90glint) f9y0glubuild2dmipmaps
   integer(f90glenum) target
   integer(f90glint) components, width, height
   integer(f90glenum) format, type
   integer(f90glint) data(*)
   end function
   function f9y1glubuild2dmipmaps(target,components,width,height,format,type, &
   data)
   use f90gl_kinds
   integer(f90glint) f9y1glubuild2dmipmaps
   integer(f90glenum) target
   integer(f90glint) components, width, height
   integer(f90glenum) format, type
   real(f90glfloat) data(*)
   end function
   function f9y2glubuild2dmipmaps(target,components,width,height,format,type, &
   data)
   use f90gl_kinds
   integer(f90glint) f9y2glubuild2dmipmaps
   integer(f90glenum) target
   integer(f90glint) components, width, height
   integer(f90glenum) format, type
   integer(f90glint) data
   end function
   function f9y3glubuild2dmipmaps(target,components,width,height,format,type, &
   data)
   use f90gl_kinds
   integer(f90glint) f9y3glubuild2dmipmaps
   integer(f90glenum) target
   integer(f90glint) components, width, height
   integer(f90glenum) format, type
   real(f90glfloat) data
   end function
   module procedure f9xglubuild2dmipmaps
end interface

interface f90glunewquadric               
   module procedure f9xglunewquadric
end interface

interface f90gludeletequadric            
   module procedure f9xgludeletequadric
end interface

interface f90gluquadricdrawstyle         
   module procedure f9xgluquadricdrawstyle
end interface

interface f90gluquadricorientation       
   module procedure f9xgluquadricorientation
end interface

interface f90gluquadricnormals           
   module procedure f9xgluquadricnormals
end interface

interface f90gluquadrictexture           
   module procedure f9xgluquadrictexture
end interface

interface f90gluquadriccallback          
   module procedure f9xgluquadriccallback
end interface

interface f90glucylinder                 
   module procedure f9xglucylinder
end interface

interface f90glusphere                   
   module procedure f9xglusphere
end interface

interface f90gludisk                     
   module procedure f9xgludisk
end interface

interface f90glupartialdisk              
   module procedure f9xglupartialdisk
end interface

interface f90glunewnurbsrenderer         
   module procedure f9xglunewnurbsrenderer
end interface

interface f90gludeletenurbsrenderer      
   module procedure f9xgludeletenurbsrenderer
end interface

interface f90gluloadsamplingmatrices     
   module procedure f9xgluloadsamplingmatrices
end interface

interface f90glunurbsproperty            
   module procedure f9xglunurbsproperty
end interface

interface f90glugetnurbsproperty         
   module procedure f9xglugetnurbsproperty
end interface

interface f90glubegincurve               
   module procedure f9xglubegincurve
end interface

interface f90gluendcurve                 
   module procedure f9xgluendcurve
end interface

interface f90glunurbscurve               
   module procedure f9xglunurbscurve
end interface

interface f90glubeginsurface             
   module procedure f9xglubeginsurface
end interface

interface f90gluendsurface               
   module procedure f9xgluendsurface
end interface

interface f90glunurbssurface             
   module procedure f9xglunurbssurface
end interface

interface f90glubegintrim                
   module procedure f9xglubegintrim
end interface

interface f90gluendtrim                  
   module procedure f9xgluendtrim
end interface

interface f90glupwlcurve                 
   module procedure f9xglupwlcurve
end interface

interface f90glunurbscallback            
   module procedure f9xglunurbscallback
end interface

interface f90glunewtess                  
   module procedure f9xglunewtess
end interface

interface f90glutesscallback             
   module procedure f9xglutesscallback
end interface

interface f90gludeletetess               
   module procedure f9xgludeletetess
end interface

interface f90glubeginpolygon             
   module procedure f9xglubeginpolygon
end interface

interface f90gluendpolygon               
   module procedure f9xgluendpolygon
end interface

interface f90glunextcontour              
   module procedure f9xglunextcontour
end interface

interface f90glutessvertex               
   module procedure f9x0glutessvertex, f9x1glutessvertex, f9x2glutessvertex, &
                   f9x3glutessvertex, f9x4glutessvertex
end interface

interface f90glugetstring                
   module procedure f9xglugetstring
end interface

contains

! fortran 90 wrappers for procedures that might have the wrong KIND of argument

function f9xgluerrorstring(errorcode)
character(len=256) f9xgluerrorstring
integer(f90glenum) errorcode
integer(f90gluint) temp(256)
integer(f90glint) length
integer i
call f9ygluerrorstring(temp,length,errorcode)
f9xgluerrorstring = ''
do i=1,length
   f9xgluerrorstring(i:i) = char(temp(i))
end do
end function f9xgluerrorstring

function f9xgluscaleimage(format,widthin,heightin,typein,datain,widthout, &
   heightout,typeout,dataout)
integer(f90glint) f9xgluscaleimage
integer(f90glenum) format
integer(f90glint) widthin, heightin
integer(f90glenum) typein
character(f90glcptr) datain
integer(f90glint) widthout, heightout
integer(f90glenum) typeout
character(f90glcptr) dataout
integer(f90gluint) temp1(f90glcptr),temp2(f90glcptr)
integer i 
do i=1,f90glcptr 
   temp1(i) = ichar(datain(i:i))
   temp2(i) = ichar(dataout(i:i))
end do
f9xgluscaleimage = f9y4gluscaleimage(format,widthin,heightin,typein,temp1,widthout, &
   heightout,typeout,temp2,f90glcptr)
end function f9xgluscaleimage

function f90gluscaleimagebyte(format,widthin,heightin,typein,datain,widthout, &
   heightout,typeout,dataout)
integer(f90glint) f90gluscaleimagebyte
integer(f90glenum) format
integer(f90glint) widthin, heightin
integer(f90glenum) typein
integer(f90glbyte) datain(*)
integer(f90glint) widthout, heightout
integer(f90glenum) typeout
integer(f90glbyte) dataout(*)
f90gluscaleimagebyte = f9y5gluscaleimage(format,widthin,heightin,typein,datain,widthout, &
   heightout,typeout,dataout)
end function f90gluscaleimagebyte

function f90gluscaleimageshort(format,widthin,heightin,typein,datain,widthout, &
   heightout,typeout,dataout)
integer(f90glint) f90gluscaleimageshort
integer(f90glenum) format
integer(f90glint) widthin, heightin
integer(f90glenum) typein
integer(f90glshort) datain(*)
integer(f90glint) widthout, heightout
integer(f90glenum) typeout
integer(f90glshort) dataout(*)
f90gluscaleimageshort = f9y6gluscaleimage(format,widthin,heightin,typein,datain,widthout, &
   heightout,typeout,dataout)
end function f90gluscaleimageshort

function f9xglubuild1dmipmaps(target,components,width,format,type,data)
integer(f90glint) f9xglubuild1dmipmaps
integer(f90glenum) target
integer(f90glint) components, width
integer(f90glenum) format, type
character(f90glcptr) data
integer(f90gluint) temp(f90glcptr) 
integer i 
do i=1,f90glcptr 
   temp(i) = ichar(data(i:i))
end do
f9xglubuild1dmipmaps = f9y4glubuild1dmipmaps(target,components,width,format, &
   type,temp,f90glcptr)
end function f9xglubuild1dmipmaps

function f90glubuild1dmipmapsbyte(target,components,width,format,type,data)
integer(f90glint) f90glubuild1dmipmapsbyte
integer(f90glenum) target
integer(f90glint) components, width
integer(f90glenum) format, type
integer(f90glbyte) data(*)
f90glubuild1dmipmapsbyte = f9y5glubuild1dmipmaps(target,components,width,format, &
   type,data)
end function f90glubuild1dmipmapsbyte

function f90glubuild1dmipmapsshort(target,components,width,format,type,data)
integer(f90glint) f90glubuild1dmipmapsshort
integer(f90glenum) target
integer(f90glint) components, width
integer(f90glenum) format, type
integer(f90glshort) data(*)
f90glubuild1dmipmapsshort = f9y6glubuild1dmipmaps(target,components,width,format, &
   type,data)
end function f90glubuild1dmipmapsshort

function f9xglubuild2dmipmaps(target,components,width,height,format,type, &
   data)
integer(f90glint) f9xglubuild2dmipmaps
integer(f90glenum) target
integer(f90glint) components, width, height
integer(f90glenum) format, type
character(f90glcptr) data
integer(f90gluint) temp(f90glcptr) 
integer i 
do i=1,f90glcptr 
   temp(i) = ichar(data(i:i))
end do
f9xglubuild2dmipmaps = f9y4glubuild2dmipmaps(target,components,width,height,format, &
   type,temp,f90glcptr)
end function f9xglubuild2dmipmaps

function f90glubuild2dmipmapsbyte(target,components,width,height,format,type, &
   data)
integer(f90glint) f90glubuild2dmipmapsbyte
integer(f90glenum) target
integer(f90glint) components, width, height
integer(f90glenum) format, type
integer(f90glbyte) data(*)
f90glubuild2dmipmapsbyte = f9y5glubuild2dmipmaps(target,components,width,height,format, &
   type,data)
end function f90glubuild2dmipmapsbyte

function f90glubuild2dmipmapsshort(target,components,width,height,format,type, &
   data)
integer(f90glint) f90glubuild2dmipmapsshort
integer(f90glenum) target
integer(f90glint) components, width, height
integer(f90glenum) format, type
integer(f90glshort) data(*)
f90glubuild2dmipmapsshort = f9y6glubuild2dmipmaps(target,components,width,height,format, &
   type,data)
end function f90glubuild2dmipmapsshort

function f9xglunewquadric()
type(f90gluquadricobj), pointer :: f9xglunewquadric
integer(f90gluint) temp(2*f90glcptr)
integer i
logical isnull
allocate(f9xglunewquadric)
call f9yglunewquadric(temp,f90glcptr)
do i=1,f90glcptr
   f9xglunewquadric%addr(1)(i:i) = char(temp(i))
   f9xglunewquadric%addr(2)(i:i) = char(temp(i+f90glcptr))
end do
! This silly one-character-at-a-time comparison is to get around an
! apparent bug in NAG f90 compiler where
! f9xglunewquadric%addr(1)==f90glnullptr is true when they're unequal
isnull = .true.
do i=1,f90glcptr
   if (f9xglunewquadric%addr(1)(i:i) /= f90glnullptr(i:i)) then
      isnull = .false.
      exit
   endif
end do
if (isnull) then
   deallocate(f9xglunewquadric)
   nullify(f9xglunewquadric)
endif
end function f9xglunewquadric

subroutine f9xgludeletequadric(state)
type(f90gluquadricobj), pointer :: state
integer(f90gluint) temp(2*f90glcptr)
integer i
do i=1,f90glcptr
   temp(i) = ichar(state%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(state%addr(2)(i:i))
end do
call f9ygludeletequadric(temp,f90glcptr)
deallocate(state)
end subroutine f9xgludeletequadric

subroutine f9xgluquadricdrawstyle(quadobject,drawstyle)
type(f90gluquadricobj) quadobject
integer(f90glenum) drawstyle
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(quadobject%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(quadobject%addr(2)(i:i))
end do
call f9ygluquadricdrawstyle(temp,f90glcptr,drawstyle)
end subroutine f9xgluquadricdrawstyle

subroutine f9xgluquadricorientation(quadobject,orientation)
type(f90gluquadricobj) quadobject
integer(f90glenum) orientation
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(quadobject%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(quadobject%addr(2)(i:i))
end do 
call f9ygluquadricorientation(temp,f90glcptr,orientation)
end subroutine f9xgluquadricorientation

subroutine f9xgluquadricnormals(quadobject,normals)
type(f90gluquadricobj) quadobject
integer(f90glenum) normals
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(quadobject%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(quadobject%addr(2)(i:i))
end do
call f9ygluquadricnormals(temp,f90glcptr,normals)
end subroutine f9xgluquadricnormals

subroutine f9xgluquadrictexture(quadobject,texturecoords)
type(f90gluquadricobj) quadobject
logical(f90glboolean) texturecoords
integer(f90glint) int_texturecoords
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(quadobject%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(quadobject%addr(2)(i:i))
end do
if (f90glone_byte_logical) then
   call f9ygluquadrictexture(temp,f90glcptr,texturecoords)
else
   if (texturecoords) then; int_texturecoords = 1; else; int_texturecoords = 0; endif
   call f9egluquadrictexture(temp,f90glcptr,int_texturecoords)
endif
end subroutine f9xgluquadrictexture

subroutine f9xgluquadriccallback(qobj,which,fn)
type(f90gluquadricobj) qobj
integer(f90glenum) which
interface
   subroutine fn(err)
   use f90gl_kinds
   integer(f90glenum) err 
   end subroutine fn
end interface
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(qobj%addr(1)(i:i)) 
   temp(i+f90glcptr) = ichar(qobj%addr(2)(i:i)) 
end do
call f9ygluquadriccallback(temp,f90glcptr,which,fn)
do i=1,f90glcptr
   qobj%addr(1)(i:i) = char(temp(i))
   qobj%addr(2)(i:i) = char(temp(i+f90glcptr))
end do
end subroutine f9xgluquadriccallback

subroutine f9xglucylinder(qobj,baseradius,topradius,height,slices,stacks)
type(f90gluquadricobj) qobj
real(f90gldouble) baseradius, topradius, height
integer(f90glint) slices, stacks
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(qobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(qobj%addr(2)(i:i))
end do
call f9yglucylinder(temp,f90glcptr,baseradius,topradius,height,slices,stacks)
end subroutine f9xglucylinder

subroutine f9xglusphere(qobj,radius,slices,stacks)
type(f90gluquadricobj) qobj
real(f90gldouble) radius
integer(f90glint) slices, stacks
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(qobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(qobj%addr(2)(i:i))
end do
call f9yglusphere(temp,f90glcptr,radius,slices,stacks)
end subroutine f9xglusphere

subroutine f9xgludisk(qobj,innerradius,outerradius,slices,loops)
type(f90gluquadricobj) qobj
real(f90gldouble) innerradius, outerradius
integer(f90glint) slices, loops
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(qobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(qobj%addr(2)(i:i))
end do
call f9ygludisk(temp,f90glcptr,innerradius,outerradius,slices,loops)
end subroutine f9xgludisk

subroutine f9xglupartialdisk(qobj,innerradius,outerradius,slices,loops, &
   startangle,sweepangle)
type(f90gluquadricobj) qobj
real(f90gldouble) innerradius, outerradius
integer(f90glint) slices, loops
real(f90gldouble) startangle, sweepangle
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(qobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(qobj%addr(2)(i:i))
end do
call f9yglupartialdisk(temp,f90glcptr,innerradius,outerradius,slices,loops, &
   startangle,sweepangle)
end subroutine f9xglupartialdisk

function f9xglunewnurbsrenderer()
type(f90glunurbsobj), pointer :: f9xglunewnurbsrenderer
integer(f90gluint) temp(2*f90glcptr)
integer i
logical isnull
allocate(f9xglunewnurbsrenderer)
call f9yglunewnurbsrenderer(temp,f90glcptr)
do i=1,f90glcptr
   f9xglunewnurbsrenderer%addr(1)(i:i) = char(temp(i))
   f9xglunewnurbsrenderer%addr(2)(i:i) = char(temp(i+f90glcptr))
end do
! This silly one-character-at-a-time comparison is to get around an
! apparent bug in NAG f90 compiler where
! f9xglunewquadric%addr(1)==f90glnullptr is true when they're unequal
isnull = .true.
do i=1,f90glcptr
   if (f9xglunewnurbsrenderer%addr(1)(i:i) /= f90glnullptr(i:i)) then
      isnull = .false.
      exit
   endif
end do
if (isnull) then
   deallocate(f9xglunewnurbsrenderer)
   nullify(f9xglunewnurbsrenderer)
endif
end function f9xglunewnurbsrenderer

subroutine f9xgludeletenurbsrenderer(nobj)
type(f90glunurbsobj), pointer :: nobj
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call fgludeletenurbsrenderer(temp,f90glcptr)
deallocate(nobj)
end subroutine f9xgludeletenurbsrenderer

subroutine f9xgluloadsamplingmatrices(nobj,modelmatrix,projmatrix,viewport)
type(f90glunurbsobj) nobj
real(f90glfloat) modelmatrix(*), projmatrix(*)
integer(f90glint) viewport(*)
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9ygluloadsamplingmatrices(temp,f90glcptr,modelmatrix,projmatrix,viewport)
end subroutine f9xgluloadsamplingmatrices

subroutine f9xglunurbsproperty(nobj,property,value)
type(f90glunurbsobj) nobj
integer(f90glenum) property
real(f90glfloat) value
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9yglunurbsproperty(temp,f90glcptr,property,value)
end subroutine f9xglunurbsproperty

subroutine f9xglugetnurbsproperty(nobj,property,value)
type(f90glunurbsobj) nobj
integer(f90glenum) property
real(f90glfloat) value
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9yglugetnurbsproperty(temp,f90glcptr,property,value)
end subroutine f9xglugetnurbsproperty

subroutine f9xglubegincurve(nobj)
type(f90glunurbsobj) nobj
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9yglubegincurve(temp,f90glcptr)
end subroutine f9xglubegincurve

subroutine f9xgluendcurve(nobj)
type(f90glunurbsobj) nobj
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9ygluendcurve(temp,f90glcptr)
end subroutine f9xgluendcurve

subroutine f9xglunurbscurve(nobj,nknots,knot,stride,ctlarray,order,type)
type(f90glunurbsobj) nobj
integer(f90glint) nknots
real(f90glfloat) knot(*)
integer(f90glint) stride
real(f90glfloat) ctlarray(*)
integer(f90glint) order
integer(f90glenum) type
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9yglunurbscurve(temp,f90glcptr,nknots,knot,stride,ctlarray,order,type)
end subroutine f9xglunurbscurve

subroutine f9xglubeginsurface(nobj)
type(f90glunurbsobj) nobj
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9yglubeginsurface(temp,f90glcptr)
end subroutine f9xglubeginsurface

subroutine f9xgluendsurface(nobj)
type(f90glunurbsobj) nobj
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9ygluendsurface(temp,f90glcptr)
end subroutine f9xgluendsurface

subroutine f9xglunurbssurface(nobj,sknot_count,sknot,tknot_count,tknot, &
   s_stride,t_stride,ctlarray,sorder,torder,type)
type(f90glunurbsobj) nobj
integer(f90glint) sknot_count
real(f90glfloat) sknot(*)
integer(f90glint) tknot_count
real(f90glfloat) tknot(*)
integer(f90glint) s_stride, t_stride
real(f90glfloat) ctlarray(*)
integer(f90glint) sorder, torder
integer(f90glenum) type
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9yglunurbssurface(temp,f90glcptr,sknot_count,sknot,tknot_count,tknot,s_stride, &
   t_stride,ctlarray,sorder,torder,type)
end subroutine f9xglunurbssurface

subroutine f9xglubegintrim(nobj)
type(f90glunurbsobj) nobj
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9yglubegintrim(temp,f90glcptr)
end subroutine f9xglubegintrim

subroutine f9xgluendtrim(nobj)
type(f90glunurbsobj) nobj
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9ygluendtrim(temp,f90glcptr)
end subroutine f9xgluendtrim

subroutine f9xglupwlcurve(nobj,count,array,stride,type)
type(f90glunurbsobj) nobj
integer(f90glint) count
real(f90glfloat) array(*)
integer(f90glint) stride
integer(f90glenum) type
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9yglupwlcurve(temp,f90glcptr,count,array,stride,type)
end subroutine f9xglupwlcurve

subroutine f9xglunurbscallback(nobj,which,fn)
type(f90glunurbsobj) nobj
integer(f90glenum) which
interface
   subroutine fn(err)
   use f90gl_kinds
   integer(f90glenum) err 
   end subroutine fn
end interface
integer(f90gluint) temp(2*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(nobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(nobj%addr(2)(i:i))
end do
call f9yglunurbscallback(temp,f90glcptr,which,fn)
do i=1,f90glcptr
   nobj%addr(1)(i:i) = char(temp(i))
   nobj%addr(2)(i:i) = char(temp(i+f90glcptr))
end do
end subroutine f9xglunurbscallback

function f9xglunewtess()
type(f90glutriangulatorobj), pointer :: f9xglunewtess
integer(f90gluint) temp(6*f90glcptr)
integer i
logical isnull
allocate(f9xglunewtess)
call f9yglunewtess(temp,f90glcptr)
do i=1,f90glcptr
   f9xglunewtess%addr(1)(i:i) = char(temp(i))
   f9xglunewtess%addr(2)(i:i) = char(temp(i+f90glcptr))
   f9xglunewtess%addr(3)(i:i) = char(temp(i+2*f90glcptr))
   f9xglunewtess%addr(4)(i:i) = char(temp(i+3*f90glcptr))
   f9xglunewtess%addr(5)(i:i) = char(temp(i+4*f90glcptr))
   f9xglunewtess%addr(6)(i:i) = char(temp(i+5*f90glcptr))
end do
! This silly one-character-at-a-time comparison is to get around an
! apparent bug in NAG f90 compiler where
! f9xglunewquadric%addr(1)==f90glnullptr is true when they're unequal
isnull = .true.
do i=1,f90glcptr
   if (f9xglunewtess%addr(1)(i:i) /= f90glnullptr(i:i)) then
      isnull = .false.
      exit
   endif
end do
if (isnull) then
   deallocate(f9xglunewtess)
   nullify(f9xglunewtess)
endif
end function f9xglunewtess

subroutine f9xglutesscallback(tobj,which,fn)
type(f90glutriangulatorobj) tobj
integer(f90glenum) which
interface
   subroutine fn(err)
   use f90gl_kinds
   integer(f90glenum) err 
   end subroutine fn
end interface
integer(f90gluint) temp(6*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(tobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(tobj%addr(2)(i:i))
   temp(i+2*f90glcptr) = ichar(tobj%addr(3)(i:i))
   temp(i+3*f90glcptr) = ichar(tobj%addr(4)(i:i))
   temp(i+4*f90glcptr) = ichar(tobj%addr(5)(i:i))
   temp(i+5*f90glcptr) = ichar(tobj%addr(6)(i:i))
end do
call f9yglutesscallback(temp,f90glcptr,which,fn)
do i=1,f90glcptr
   tobj%addr(1)(i:i) = char(temp(i))
   tobj%addr(2)(i:i) = char(temp(i+f90glcptr))
   tobj%addr(3)(i:i) = char(temp(i+2*f90glcptr))
   tobj%addr(4)(i:i) = char(temp(i+3*f90glcptr))
   tobj%addr(5)(i:i) = char(temp(i+4*f90glcptr))
   tobj%addr(6)(i:i) = char(temp(i+5*f90glcptr))
end do
end subroutine f9xglutesscallback

subroutine f9xgludeletetess(tobj)
type(f90glutriangulatorobj),pointer :: tobj
integer(f90gluint) temp(6*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(tobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(tobj%addr(2)(i:i))
   temp(i+2*f90glcptr) = ichar(tobj%addr(3)(i:i))
   temp(i+3*f90glcptr) = ichar(tobj%addr(4)(i:i))
   temp(i+4*f90glcptr) = ichar(tobj%addr(5)(i:i))
   temp(i+5*f90glcptr) = ichar(tobj%addr(6)(i:i))
end do
call fgludeletetess(temp,f90glcptr)
deallocate(tobj)
end subroutine f9xgludeletetess

subroutine f9xglubeginpolygon(tobj)
type(f90glutriangulatorobj) tobj
integer(f90gluint) temp(6*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(tobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(tobj%addr(2)(i:i))
   temp(i+2*f90glcptr) = ichar(tobj%addr(3)(i:i))
   temp(i+3*f90glcptr) = ichar(tobj%addr(4)(i:i))
   temp(i+4*f90glcptr) = ichar(tobj%addr(5)(i:i))
   temp(i+5*f90glcptr) = ichar(tobj%addr(6)(i:i))
end do
call f9yglubeginpolygon(temp,f90glcptr)
end subroutine f9xglubeginpolygon

subroutine f9xgluendpolygon(tobj)
type(f90glutriangulatorobj) tobj
integer(f90gluint) temp(6*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(tobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(tobj%addr(2)(i:i))
   temp(i+2*f90glcptr) = ichar(tobj%addr(3)(i:i))
   temp(i+3*f90glcptr) = ichar(tobj%addr(4)(i:i))
   temp(i+4*f90glcptr) = ichar(tobj%addr(5)(i:i))
   temp(i+5*f90glcptr) = ichar(tobj%addr(6)(i:i))
end do
call f9ygluendpolygon(temp,f90glcptr)
end subroutine f9xgluendpolygon

subroutine f9xglunextcontour(tobj,type)
type(f90glutriangulatorobj) tobj
integer(f90glenum) type
integer(f90gluint) temp(6*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(tobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(tobj%addr(2)(i:i))
   temp(i+2*f90glcptr) = ichar(tobj%addr(3)(i:i))
   temp(i+3*f90glcptr) = ichar(tobj%addr(4)(i:i))
   temp(i+4*f90glcptr) = ichar(tobj%addr(5)(i:i))
   temp(i+5*f90glcptr) = ichar(tobj%addr(6)(i:i))
end do
call f9yglunextcontour(temp,f90glcptr,type)
end subroutine f9xglunextcontour

subroutine f9x0glutessvertex(tobj,v,data)
type(f90glutriangulatorobj) tobj
real(f90gldouble) v(*)
integer(f90glint) data(*)
integer(f90gluint) temp(6*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(tobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(tobj%addr(2)(i:i))
   temp(i+2*f90glcptr) = ichar(tobj%addr(3)(i:i))
   temp(i+3*f90glcptr) = ichar(tobj%addr(4)(i:i))
   temp(i+4*f90glcptr) = ichar(tobj%addr(5)(i:i))
   temp(i+5*f90glcptr) = ichar(tobj%addr(6)(i:i))
end do
call f9y0glutessvertex(temp,f90glcptr,v,data)
end subroutine f9x0glutessvertex

subroutine f9x1glutessvertex(tobj,v,data)
type(f90glutriangulatorobj) tobj
real(f90gldouble) v(*)
real(f90glfloat) data(*)
integer(f90gluint) temp(6*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(tobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(tobj%addr(2)(i:i))
   temp(i+2*f90glcptr) = ichar(tobj%addr(3)(i:i))
   temp(i+3*f90glcptr) = ichar(tobj%addr(4)(i:i))
   temp(i+4*f90glcptr) = ichar(tobj%addr(5)(i:i))
   temp(i+5*f90glcptr) = ichar(tobj%addr(6)(i:i))
end do
call f9y1glutessvertex(temp,f90glcptr,v,data)
end subroutine f9x1glutessvertex

subroutine f9x2glutessvertex(tobj,v,data)
type(f90glutriangulatorobj) tobj
real(f90gldouble) v(*)
integer(f90glint) data
integer(f90gluint) temp(6*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(tobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(tobj%addr(2)(i:i))
   temp(i+2*f90glcptr) = ichar(tobj%addr(3)(i:i))
   temp(i+3*f90glcptr) = ichar(tobj%addr(4)(i:i))
   temp(i+4*f90glcptr) = ichar(tobj%addr(5)(i:i))
   temp(i+5*f90glcptr) = ichar(tobj%addr(6)(i:i))
end do
call f9y2glutessvertex(temp,f90glcptr,v,data)
end subroutine f9x2glutessvertex

subroutine f9x3glutessvertex(tobj,v,data)
type(f90glutriangulatorobj) tobj
real(f90gldouble) v(*)
real(f90glfloat) data
integer(f90gluint) temp(6*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(tobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(tobj%addr(2)(i:i))
   temp(i+2*f90glcptr) = ichar(tobj%addr(3)(i:i))
   temp(i+3*f90glcptr) = ichar(tobj%addr(4)(i:i))
   temp(i+4*f90glcptr) = ichar(tobj%addr(5)(i:i))
   temp(i+5*f90glcptr) = ichar(tobj%addr(6)(i:i))
end do
call f9y3glutessvertex(temp,f90glcptr,v,data)
end subroutine f9x3glutessvertex

subroutine f9x4glutessvertex(tobj,v,data)
type(f90glutriangulatorobj) tobj
real(f90gldouble) v(*)
character(f90glcptr) data
integer(f90gluint) temp(6*f90glcptr),temp2(f90glcptr)
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(tobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(tobj%addr(2)(i:i))
   temp(i+2*f90glcptr) = ichar(tobj%addr(3)(i:i))
   temp(i+3*f90glcptr) = ichar(tobj%addr(4)(i:i))
   temp(i+4*f90glcptr) = ichar(tobj%addr(5)(i:i))
   temp(i+5*f90glcptr) = ichar(tobj%addr(6)(i:i))
   temp2(i) = ichar(data(i:i))
end do
call f9y4glutessvertex(temp,f90glcptr,v,temp2)
end subroutine f9x4glutessvertex

subroutine f90glutessvertexbyte(tobj,v,data)
type(f90glutriangulatorobj) tobj
real(f90gldouble) v(*)
integer(f90glbyte) data(*)
integer(f90gluint) temp(6*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(tobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(tobj%addr(2)(i:i))
   temp(i+2*f90glcptr) = ichar(tobj%addr(3)(i:i))
   temp(i+3*f90glcptr) = ichar(tobj%addr(4)(i:i))
   temp(i+4*f90glcptr) = ichar(tobj%addr(5)(i:i))
   temp(i+5*f90glcptr) = ichar(tobj%addr(6)(i:i))
end do
call f9y5glutessvertex(temp,f90glcptr,v,data)
end subroutine f90glutessvertexbyte

subroutine f90glutessvertexshort(tobj,v,data)
type(f90glutriangulatorobj) tobj
real(f90gldouble) v(*)
integer(f90glshort) data(*)
integer(f90gluint) temp(6*f90glcptr) 
integer i  
do i=1,f90glcptr 
   temp(i) = ichar(tobj%addr(1)(i:i))
   temp(i+f90glcptr) = ichar(tobj%addr(2)(i:i))
   temp(i+2*f90glcptr) = ichar(tobj%addr(3)(i:i))
   temp(i+3*f90glcptr) = ichar(tobj%addr(4)(i:i))
   temp(i+4*f90glcptr) = ichar(tobj%addr(5)(i:i))
   temp(i+5*f90glcptr) = ichar(tobj%addr(6)(i:i))
end do
call f9y6glutessvertex(temp,f90glcptr,v,data)
end subroutine f90glutessvertexshort

function f9xglugetstring(name)
character(len=256) f9xglugetstring
integer(f90glenum) name
integer(f90gluint) temp(256)
integer(f90glint) length
integer i
call f9yglugetstring(temp,length,name)
f9xglugetstring = ''
do i=1,length
   f9xglugetstring(i:i) = char(temp(i))
end do
end function f9xglugetstring

end module f90glu
