/*-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for Mesa software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------*/

#ifdef FBIND


#include <string.h>
#include <GL/gl.h>
#include <gltk.h>
#define MIN2( A, B )   ( (A)<(B) ? (A) : (B) )

/* equalence of types

 OpenGL          description              C     extended fortan 77

GLboolean   8-bit unsigned integer  unsigned char  logical*1
GLbyte      8-bit integer           signed char    integer*1
GLubyte     8-bit unsigned integer  unsigned char  integer*1
GLshort    16-bit integer           short          integer*2
GLushort   16-bit unsigned integer  unsigned short integer*2
GLint      32-bit integer           long           integer*4
GLuint     32-bit unsigned integer  unsigned long  integer*4
GLenum     32-bit unsigned integer  unsigned long  integer*4
GLbitfield 32-bit unsigned integer  unsigned long  integer*4
GLsizei    32-bit integer           long           integer*4
GLfloat    32-bit floating point    float          real*4
GLclampf   32-bit floating point    float          real*4
GLdouble   64-bit floating point    double         real*8
GLclampd   64-bit floating point    double         real*8
GLvoid     generic pointer GLvoid*  void           any array


   f90gl            fortran 90

f90glboolean    logical(kind=k) where k gives a 1 byte logical, if possible
f90glbyte       selected_int_kind(2)
f90glubyte      selected_int_kind(2)
f90glshort      selected_int_kind(4)
f90glushort     selected_int_kind(4)
f90glint        selected_int_kind(9)
f90gluint       selected_int_kind(9)
f90glenum       selected_int_kind(9)
f90glbitfield   selected_int_kind(9)
f90glsizei      selected_int_kind(9)
f90glfloat      selected_real_kind(6)
f90glclampf     selected_real_kind(6)
f90gldouble     selected_real_kind(15)
f90glclampd     selected_real_kind(15)
f90glvoid       any array

*/

/*
 * Mapping of Fortran types to C types:
 */

#define f90glboolean  unsigned char *
#define f90glbyte     signed char *
#define f90glubyte    unsigned char *
#define f90glshort    short *
#define f90glushort   unsigned short *
#define f90glint      long *
#define f90gluint     unsigned long *
#define f90glenum     unsigned long *
#define f90glbitfield unsigned long *
#define f90glsizei    long *
#define f90glfloat    float *
#define f90glclampf   float *
#define f90gldouble   double *
#define f90glclampd   double *
#define f90glvoid     long *
#define f90glcint     int *
#define f90glcfloat   float *

#define end_of_string '\0'
/* procedure name mangling */

#if FBIND==1
#define f9ytkInitWindow                f9ytkinitwindow
#define f9btkNewCursor                 f9btknewcursor
#define f9ctkNewCursor                 f9ctknewcursor
#define f9ytkRGBImageLoad              f9ytkrgbimageload
#define f9ytkDrawStr                   f9ytkdrawstr
#define f9ytkGetSystem                 f9ytkgetsystem
#elif FBIND==2
#define f9ytkInitWindow                f9ytkinitwindow_
#define f9btkNewCursor                 f9btknewcursor_
#define f9ctkNewCursor                 f9ctknewcursor_
#define f9ytkRGBImageLoad              f9ytkrgbimageload_
#define f9ytkDrawStr                   f9ytkdrawstr_
#define f9ytkGetSystem                 f9ytkgetsystem_
#elif FBIND==3
#define f9ytkInitWindow                F9YTKINITWINDOW
#define f9btkNewCursor                 F9BTKNEWCURSOR
#define f9ctkNewCursor                 F9CTKNEWCURSOR
#define f9ytkRGBImageLoad              F9YTKRGBIMAGELOAD
#define f9ytkDrawStr                   F9YTKDRAWSTR
#define f9ytkGetSystem                 F9YTKGETSYSTEM
#endif

/* wrapper functions that change types */

GLenum f9ytkInitWindow(f90gluint title, f90glint size_title )
{
   unsigned char *char_title = (unsigned char *)malloc((*size_title+1)*sizeof(unsigned char));
   int i;
   for (i=0;i<*size_title;i++) char_title[i]=(unsigned char) title[i];
   char_title[*size_title] = end_of_string;
   return (GLenum) tkInitWindow( char_title);
}

void f9btkNewCursor(f90glint id,f90gluint shapeBuf,f90gluint maskBuf,
   f90glenum fgColor,f90glenum bgColor,f90glint hotX,f90glint hotY )
{
   GLubyte byte_shapeBuf[32];
   GLubyte byte_maskBuf[32];
   int i;
   for (i=0;i<32;i++) byte_shapeBuf[i]=(GLubyte) shapeBuf[i];
   for (i=0;i<32;i++) byte_maskBuf[i]=(GLubyte) maskBuf[i];
   tkNewCursor( (GLint) *id, byte_shapeBuf, byte_maskBuf, (GLenum) *fgColor,
    (GLenum) *bgColor, (GLint) *hotX, (GLint) *hotY);
   for (i=0;i<32;i++) shapeBuf[i]=(GLuint) byte_shapeBuf[i];
   for (i=0;i<32;i++) maskBuf[i]=(GLuint) byte_maskBuf[i];
}

void f9ctkNewCursor(f90glint id,f90glushort shapeBuf,f90glushort maskBuf,
   f90glenum fgColor,f90glenum bgColor,f90glint hotX,f90glint hotY )
{
   GLubyte byte_shapeBuf[32];
   GLubyte byte_maskBuf[32];
   int i;
   for (i=0;i<32;i++) byte_shapeBuf[i]=(GLubyte) shapeBuf[i];
   for (i=0;i<32;i++) byte_maskBuf[i]=(GLubyte) maskBuf[i];
   tkNewCursor( (GLint) *id, byte_shapeBuf, byte_maskBuf, (GLenum) *fgColor,
    (GLenum) *bgColor, (GLint) *hotX, (GLint) *hotY);
   for (i=0;i<32;i++) shapeBuf[i]=(GLushort) byte_shapeBuf[i];
   for (i=0;i<32;i++) maskBuf[i]=(GLushort) byte_maskBuf[i];
}

void f9ytkRGBImageLoad(f90gluint fileName, f90glint size_fileName,
            f90glint sizex, f90glint sizey, f90gluint data, f90glint nbytes )
{
   unsigned char *char_fileName = (unsigned char *)malloc((*size_fileName+1)*sizeof(unsigned char));
   unsigned char *p;
   int i;
   TK_RGBImageRec *result;
   for (i=0;i<*size_fileName;i++) char_fileName[i]=(unsigned char) fileName[i];
   char_fileName[*size_fileName] = end_of_string;
   result = (TK_RGBImageRec *) tkRGBImageLoad( char_fileName);
   *sizex = result->sizeX;
   *sizey = result->sizeY;
   p = (unsigned char *) &(result->data);
   for (i=0; i<(*nbytes); i++) { data[i] = (GLuint)*p; p++;}
}

void f9ytkDrawStr(f90gluint base, f90gluint str, f90glint size_str )
{
   unsigned char *char_str = (unsigned char *)malloc((*size_str+1)*sizeof(unsigned char));
   int i;
   for (i=0;i<*size_str;i++) char_str[i]=(unsigned char) str[i];
   char_str[*size_str] = end_of_string;
   tkDrawStr( (GLuint) *base, char_str);
}

void f9ytkGetSystem( f90glenum type, f90gluint temp, f90glint nbytes)
{
   GLvoid *ptr;
   unsigned char *p; 
   int i;
   tkGetSystem( (GLenum) *type, ptr );
   p = (unsigned char *) &ptr;
   for (i=0; i<(*nbytes); i++) {temp[i]=(GLuint)*p; p++;}
}

#else /*ifdef FBIND*/



/* If FBIND is not defined, Fortran bindings aren't made.  Need this
 * dummy function for some picky compilers.
 */
static void dummy()
{
   return;
}

 
 
#endif /*ifdef FBIND*/
