!-------------------------------------------------------------------------
! f90gl Version 1.0 September 1996
! 
! William F. Mitchell
! Applied and Computational Mathematics Division
! National Institute of Standards and Technology
! Gaithersburg, MD 20899
! william.mitchell@nist.gov
! 
! This fortran interface for Mesa software and documentation have been produced
! as part of work done by the U.S. Government, and are not subject to copyright
! in the United States.
! 
! The mention of specific products, trademarks, or brand names in the
! documentation is for purposes of identification only.  Such mention is not to
! be interpreted in any way as an endorsement or certification of such products
! or brands by the National Institute of Standards and Technology.
! All trademarks mentioned herein belong to their respective owners.
!-------------------------------------------------------------------------

module f90gltk

use f90gl_kinds

! structures

type f90tk_rgbimagerec
   integer(f90glint) :: sizex, sizey
   character(f90glcptr) :: data
end type f90tk_rgbimagerec

! Constants

integer(f90glbitfield), parameter :: TK_RGB = 0
integer(f90glbitfield), parameter :: TK_INDEX = 1
integer(f90glbitfield), parameter :: TK_SINGLE = 0
integer(f90glbitfield), parameter :: TK_DOUBLE = 2
integer(f90glbitfield), parameter :: TK_DIRECT = 0
integer(f90glbitfield), parameter :: TK_INDIRECT = 4
integer(f90glbitfield), parameter :: TK_ACCUM = 8
integer(f90glbitfield), parameter :: TK_ALPHA = 16
integer(f90glbitfield), parameter :: TK_DEPTH = 32
integer(f90glbitfield), parameter :: TK_STENCIL = 64
integer(f90glbitfield), parameter :: TK_OVERLAY = 128
integer(f90glbitfield), parameter :: TK_UNDERLAY = 256
integer(f90glenum), parameter :: TK_X_DISPLAY = 1
integer(f90glenum), parameter :: TK_X_WINDOW = 2
integer(f90glint), parameter :: TK_LEFTBUTTON = 1
integer(f90glint), parameter :: TK_RIGHTBUTTON = 2
integer(f90glint), parameter :: TK_MIDDLEBUTTON = 4
integer(f90glenum), parameter :: TK_SHIFT = 1
integer(f90glenum), parameter :: TK_CONTROL = 2
integer(f90glint), parameter :: TK_RETURN = 13 ! 0x0D
integer(f90glint), parameter :: TK_ESCAPE = 16 + 11 ! 0x1B
integer(f90glint), parameter :: TK_SPACE = 2*16 ! 0x20
integer(f90glint), parameter :: TK_LEFT = 2*16 + 5 ! 0x25
integer(f90glint), parameter :: TK_UP = 2*16 + 6 ! 0x26
integer(f90glint), parameter :: TK_RIGHT = 2*16 + 7 ! 0x27
integer(f90glint), parameter :: TK_DOWN = 2*16 + 8 ! 0x28
integer(f90glint), parameter :: TK_A = ichar('A')
integer(f90glint), parameter :: TK_B = ichar('B')
integer(f90glint), parameter :: TK_C = ichar('C')
integer(f90glint), parameter :: TK_D = ichar('D')
integer(f90glint), parameter :: TK_E = ichar('E')
integer(f90glint), parameter :: TK_F = ichar('F')
integer(f90glint), parameter :: TK_G = ichar('G')
integer(f90glint), parameter :: TK_H = ichar('H')
integer(f90glint), parameter :: TK_I = ichar('I')
integer(f90glint), parameter :: TK_J = ichar('J')
integer(f90glint), parameter :: TK_K = ichar('K')
integer(f90glint), parameter :: TK_L = ichar('L')
integer(f90glint), parameter :: TK_M = ichar('M')
integer(f90glint), parameter :: TK_N = ichar('N')
integer(f90glint), parameter :: TK_O = ichar('O')
integer(f90glint), parameter :: TK_P = ichar('P')
integer(f90glint), parameter :: TK_Q = ichar('Q')
integer(f90glint), parameter :: TK_R = ichar('R')
integer(f90glint), parameter :: TK_S = ichar('S')
integer(f90glint), parameter :: TK_T = ichar('T')
integer(f90glint), parameter :: TK_U = ichar('U')
integer(f90glint), parameter :: TK_V = ichar('V')
integer(f90glint), parameter :: TK_W = ichar('W')
integer(f90glint), parameter :: TK_X = ichar('X')
integer(f90glint), parameter :: TK_Y = ichar('Y')
integer(f90glint), parameter :: TK_Z = ichar('Z')
integer(f90glint), parameter :: TK_lc_a = ichar('a')
integer(f90glint), parameter :: TK_lc_b = ichar('b')
integer(f90glint), parameter :: TK_lc_c = ichar('c')
integer(f90glint), parameter :: TK_lc_d = ichar('d')
integer(f90glint), parameter :: TK_lc_e = ichar('e')
integer(f90glint), parameter :: TK_lc_f = ichar('f')
integer(f90glint), parameter :: TK_lc_g = ichar('g')
integer(f90glint), parameter :: TK_lc_h = ichar('h')
integer(f90glint), parameter :: TK_lc_i = ichar('i')
integer(f90glint), parameter :: TK_lc_j = ichar('j')
integer(f90glint), parameter :: TK_lc_k = ichar('k')
integer(f90glint), parameter :: TK_lc_l = ichar('l')
integer(f90glint), parameter :: TK_lc_m = ichar('m')
integer(f90glint), parameter :: TK_lc_n = ichar('n')
integer(f90glint), parameter :: TK_lc_o = ichar('o')
integer(f90glint), parameter :: TK_lc_p = ichar('p')
integer(f90glint), parameter :: TK_lc_q = ichar('q')
integer(f90glint), parameter :: TK_lc_r = ichar('r')
integer(f90glint), parameter :: TK_lc_s = ichar('s')
integer(f90glint), parameter :: TK_lc_t = ichar('t')
integer(f90glint), parameter :: TK_lc_u = ichar('u')
integer(f90glint), parameter :: TK_lc_v = ichar('v')
integer(f90glint), parameter :: TK_lc_w = ichar('w')
integer(f90glint), parameter :: TK_lc_x = ichar('x')
integer(f90glint), parameter :: TK_lc_y = ichar('y')
integer(f90glint), parameter :: TK_lc_z = ichar('z')
integer(f90glint), parameter :: TK_0 = ichar('0')
integer(f90glint), parameter :: TK_1 = ichar('1')
integer(f90glint), parameter :: TK_2 = ichar('2')
integer(f90glint), parameter :: TK_3 = ichar('3')
integer(f90glint), parameter :: TK_4 = ichar('4')
integer(f90glint), parameter :: TK_5 = ichar('5')
integer(f90glint), parameter :: TK_6 = ichar('6')
integer(f90glint), parameter :: TK_7 = ichar('7')
integer(f90glint), parameter :: TK_8 = ichar('8')
integer(f90glint), parameter :: TK_9 = ichar('9')
integer(f90glenum), parameter :: TK_BLACK = 0
integer(f90glenum), parameter :: TK_RED = 1
integer(f90glenum), parameter :: TK_GREEN = 2
integer(f90glenum), parameter :: TK_YELLOW = 3
integer(f90glenum), parameter :: TK_BLUE = 4
integer(f90glenum), parameter :: TK_MAGENTA = 5
integer(f90glenum), parameter :: TK_CYAN = 6
integer(f90glenum), parameter :: TK_WHITE = 7


! interface blocks

interface f90tkinitdisplaymode           
   subroutine ftkinitdisplaymode(type)
   use f90gl_kinds
   integer(f90glenum) type
   end subroutine
end interface

interface f90tkinitposition              
   subroutine ftkinitposition(x,y,width,height)
   use f90gl_kinds
   integer(f90glcint) x, y, width, height
   end subroutine
end interface

interface f90tkinitwindow                
   module procedure f9xtkinitwindow
end interface

interface f90tkclosewindow               
   subroutine ftkclosewindow()
   use f90gl_kinds
   end subroutine
end interface

interface f90tkquit                      
   subroutine ftkquit()
   use f90gl_kinds
   end subroutine
end interface

interface f90tksetwindowlevel            
   function ftksetwindowlevel(level)
   use f90gl_kinds
   integer(f90glenum) ftksetwindowlevel
   integer(f90glenum) level
   end function
end interface

interface f90tkswapbuffers               
   subroutine ftkswapbuffers()
   use f90gl_kinds
   end subroutine
end interface

interface f90tkexec                      
   subroutine ftkexec()
   use f90gl_kinds
   end subroutine
end interface

interface f90tkgetcolormapsize           
   function ftkgetcolormapsize()
   use f90gl_kinds
   integer(f90glcint) ftkgetcolormapsize
   end function
end interface

interface f90tkgetmouseloc               
   subroutine ftkgetmouseloc(x,y)
   use f90gl_kinds
   integer(f90glcint) x, y
   end subroutine
end interface

interface f90tkgetsystem                 
   module procedure f9xtkgetsystem
end interface

interface f90tksetonecolor               
   subroutine ftksetonecolor(index,r,g,b)
   use f90gl_kinds
   integer(f90glcint) index
   real(f90glcfloat) r, g, b
   end subroutine
end interface

interface f90tksetfogramp                
   subroutine ftksetfogramp(density,startindex)
   use f90gl_kinds
   integer(f90glcint) density, startindex
   end subroutine
end interface

interface f90tksetgreyramp               
   subroutine ftksetgreyramp()
   use f90gl_kinds
   end subroutine
end interface

interface f90tksetrgbmap                 
   subroutine ftksetrgbmap(size,rbg)
   use f90gl_kinds
   integer(f90glcint) size
   real(f90glcfloat) rbg(*)
   end subroutine
end interface

interface f90tksetoverlaymap             
   subroutine ftksetoverlaymap(size,rgb)
   use f90gl_kinds
   integer(f90glcint) size
   real(f90glcfloat) rgb(*)
   end subroutine
end interface

interface f90tknewcursor                 
   module procedure f9xtknewcursor
end interface

interface f90tksetcursor                 
   subroutine ftksetcursor(id)
   use f90gl_kinds
   integer(f90glint) id
   end subroutine
end interface

interface f90tkrgbimageload              
   module procedure f9xtkrgbimageload
end interface

interface f90tkcreatestrokefont          
   function ftkcreatestrokefont(fontbase)
   use f90gl_kinds
   integer(f90glenum) ftkcreatestrokefont
   integer(f90gluint) fontbase
   end function
end interface

interface f90tkcreateoutlinefont         
   function ftkcreateoutlinefont(fontbase)
   use f90gl_kinds
   integer(f90glenum) ftkcreateoutlinefont
   integer(f90gluint) fontbase
   end function
end interface

interface f90tkcreatefilledfont          
   function ftkcreatefilledfont(fontbase)
   use f90gl_kinds
   integer(f90glenum) ftkcreatefilledfont
   integer(f90gluint) fontbase
   end function
end interface

interface f90tkcreatebitmapfont          
   function ftkcreatebitmapfont(fontbase)
   use f90gl_kinds
   integer(f90glenum) ftkcreatebitmapfont
   integer(f90gluint) fontbase
   end function
end interface

interface f90tkdrawstr                   
   module procedure f9xtkdrawstr
end interface

interface f90tkwiresphere                
   subroutine ftkwiresphere(base,radius)
   use f90gl_kinds
   integer(f90gluint) base
   real(f90glcfloat) radius
   end subroutine
end interface

interface f90tksolidsphere               
   subroutine ftksolidsphere(base,radius)
   use f90gl_kinds
   integer(f90gluint) base
   real(f90glcfloat) radius
   end subroutine
end interface

interface f90tkwirecube                  
   subroutine ftkwirecube(base,size)
   use f90gl_kinds
   integer(f90gluint) base
   real(f90glcfloat) size
   end subroutine
end interface

interface f90tksolidcube                 
   subroutine ftksolidcube(base,size)
   use f90gl_kinds
   integer(f90gluint) base
   real(f90glcfloat) size
   end subroutine
end interface

interface f90tkwirebox                   
   subroutine ftkwirebox(base,width,height,depth)
   use f90gl_kinds
   integer(f90gluint) base
   real(f90glcfloat) width, height, depth
   end subroutine
end interface

interface f90tksolidbox                  
   subroutine ftksolidbox(base,width,height,depth)
   use f90gl_kinds
   integer(f90gluint) base
   real(f90glcfloat) width, height, depth
   end subroutine
end interface

interface f90tkwiretorus                 
   subroutine ftkwiretorus(base,innerradius,outerradius)
   use f90gl_kinds
   integer(f90gluint) base
   real(f90glcfloat) innerradius, outerradius
   end subroutine
end interface

interface f90tksolidtorus                
   subroutine ftksolidtorus(base,innerradius,outerradius)
   use f90gl_kinds
   integer(f90gluint) base
   real(f90glcfloat) innerradius, outerradius
   end subroutine
end interface

interface f90tkwirecylinder              
   subroutine ftkwirecylinder(base,radius,height)
   use f90gl_kinds
   integer(f90gluint) base
   real(f90glcfloat) radius, height
   end subroutine
end interface

interface f90tksolidcylinder             
   subroutine ftksolidcylinder(base,radius,height)
   use f90gl_kinds
   integer(f90gluint) base
   real(f90glcfloat) radius, height
   end subroutine
end interface

interface f90tkwirecone                  
   subroutine ftkwirecone(base,b,h)
   use f90gl_kinds
   integer(f90gluint) base
   real(f90glcfloat) b, h
   end subroutine
end interface

interface f90tksolidcone                 
   subroutine ftksolidcone(base,b,h)
   use f90gl_kinds
   integer(f90gluint) base
   real(f90glcfloat) b, h
   end subroutine
end interface

interface f90tkexposefunc
   subroutine ftkexposefunc(exposefunc)
   use f90gl_kinds
   interface
      subroutine exposefunc(width, height)
      use f90gl_kinds
      integer(f90glcint) width, height
      end subroutine exposefunc
   end interface
   end subroutine
end interface

interface f90tkreshapefunc
   subroutine ftkreshapefunc(reshapefunc)
   use f90gl_kinds
   interface
      subroutine reshapefunc(width, height)
      use f90gl_kinds
      integer(f90glcint) width, height
      end subroutine reshapefunc
   end interface
   end subroutine
end interface

interface f90tkdisplayfunc
   subroutine ftkdisplayfunc(displayfunc)
   use f90gl_kinds
   interface
      subroutine displayfunc
      use f90gl_kinds
      end subroutine displayfunc
   end interface
   end subroutine
end interface

interface f90tkkeydownfunc
   subroutine ftkkeydownfunc(keydownfunc)
   use f90gl_kinds
   interface
      function keydownfunc(key, mask)
      use f90gl_kinds
      integer(f90glenum) keydownfunc
      integer(f90glcint) key
      integer(f90glenum) mask
      end function keydownfunc
   end interface
   end subroutine
end interface

interface f90tkmousedownfunc
   subroutine ftkmousedownfunc(mousedownfunc)
   use f90gl_kinds
   interface
      function mousedownfunc(x, y, mask)
      use f90gl_kinds
      integer(f90glenum) mousedownfunc
      integer(f90glcint) x, y
      integer(f90glenum) mask
      end function mousedownfunc
   end interface
   end subroutine
end interface

interface f90tkmouseupfunc
   subroutine ftkmouseupfunc(mouseupfunc)
   use f90gl_kinds
   interface
      function mouseupfunc(x, y, mask)
      use f90gl_kinds
      integer(f90glenum) mouseupfunc
      integer(f90glcint) x, y
      integer(f90glenum) mask
      end function mouseupfunc
   end interface
   end subroutine
end interface

interface f90tkmousemovefunc
   subroutine ftkmousemovefunc(mousemovefunc)
   use f90gl_kinds
   interface
      function mousemovefunc(x, y, mask)
      use f90gl_kinds
      integer(f90glenum) mousemovefunc
      integer(f90glcint) x, y
      integer(f90glenum) mask
      end function mousemovefunc
   end interface
   end subroutine
end interface

interface f90tkidlefunc
   subroutine ftkidlefunc(idlefunc)
   use f90gl_kinds
   interface
      subroutine idlefunc
      use f90gl_kinds
      end subroutine idlefunc
   end interface
   end subroutine
end interface

interface f90tk_is_rgb
   function ftk_is_rgb(x)
   use f90gl_kinds
   integer(f90glcint) ftk_is_rgb
   integer(f90glcint) x
   end function
end interface

interface f90tk_is_index
   function ftk_is_index(x)
   use f90gl_kinds
   integer(f90glcint) ftk_is_index
   integer(f90glcint) x
   end function
end interface

interface f90tk_is_single
   function ftk_is_single(x)
   use f90gl_kinds
   integer(f90glcint) ftk_is_single
   integer(f90glcint) x
   end function
end interface

interface f90tk_is_double
   function ftk_is_double(x)
   use f90gl_kinds
   integer(f90glcint) ftk_is_double
   integer(f90glcint) x
   end function
end interface

interface f90tk_is_direct
   function ftk_is_direct(x)
   use f90gl_kinds
   integer(f90glcint) ftk_is_direct
   integer(f90glcint) x
   end function
end interface

interface f90tk_is_indirect
   function ftk_is_indirect(x)
   use f90gl_kinds
   integer(f90glcint) ftk_is_indirect
   integer(f90glcint) x
   end function
end interface

interface f90tk_has_accum
   function ftk_has_accum(x)
   use f90gl_kinds
   integer(f90glcint) ftk_has_accum
   integer(f90glcint) x
   end function
end interface

interface f90tk_has_alpha
   function ftk_has_alpha(x)
   use f90gl_kinds
   integer(f90glcint) ftk_has_alpha
   integer(f90glcint) x
   end function
end interface

interface f90tk_has_depth
   function ftk_has_depth(x)
   use f90gl_kinds
   integer(f90glcint) ftk_has_depth
   integer(f90glcint) x
   end function
end interface

interface f90tk_has_overlay
   function ftk_has_overlay(x)
   use f90gl_kinds
   integer(f90glcint) ftk_has_overlay
   integer(f90glcint) x
   end function
end interface

interface f90tk_has_underlay
   function ftk_has_underlay(x)
   use f90gl_kinds
   integer(f90glcint) ftk_has_underlay
   integer(f90glcint) x
   end function
end interface

interface f90tk_has_stencil
   function ftk_has_stencil(x)
   use f90gl_kinds
   integer(f90glcint) ftk_has_stencil
   integer(f90glcint) x
   end function
end interface

interface f90tk_setcolor
   subroutine ftk_setcolor(x,y)
   use f90gl_kinds
   integer(f90glcint) x,y
   end subroutine
end interface

contains

! fortran 90 wrappers for procedures that might have the wrong KIND of argument

function f9xtkinitwindow(title)
integer(f90glenum) f9xtkinitwindow
integer(f90glenum), external :: f9ytkinitwindow
character(len=*) title
integer(f90gluint) int_title(len_trim(title))
integer i
int_title = (/ (ichar(title(i:i)),i=1,len_trim(title)) /)
f9xtkinitwindow = f9ytkinitwindow(int_title,len_trim(title))
end function f9xtkinitwindow

subroutine f9xtkgetsystem(type,ptr)
integer(f90glenum) type
character(f90glcptr) ptr
integer(f90gluint) temp(f90glcptr) 
integer i 
call f9ytkgetsystem(type,temp,f90glcptr)
do i=1,f90glcptr 
   ptr(i:i) = char(temp(i))
end do
end subroutine f9xtkgetsystem

subroutine f9xtknewcursor(id,shapebuf,maskbuf,fgcolor,bgcolor,hotx,hoty)
integer(f90glint) id
integer(f90glubyte) shapebuf(*), maskbuf(*)
integer(f90glenum) fgcolor, bgcolor
integer(f90glint) hotx, hoty
if (f90glbyte_is_int) then
   call f9btknewcursor(id,shapebuf,maskbuf,fgcolor,bgcolor,hotx,hoty)
elseif (f90glbyte_is_short) then
   call f9ctknewcursor(id,shapebuf,maskbuf,fgcolor,bgcolor,hotx,hoty)
else
   call ftknewcursor(id,shapebuf,maskbuf,fgcolor,bgcolor,hotx,hoty)
endif
end subroutine f9xtknewcursor

function f9xtkrgbimageload(filename)
type (f90tk_rgbimagerec), pointer :: f9xtkrgbimageload
character(len=*) filename
integer(f90gluint) int_filename(len_trim(filename))
integer i
integer(f90glint) :: sizex, sizey
integer(f90gluint) :: data(f90glcptr)
allocate(f9xtkrgbimageload)
int_filename = (/ (ichar(filename(i:i)),i=1,len_trim(filename)) /)
call f9ytkrgbimageload(int_filename,len_trim(filename),sizex,sizey,data,f90glcptr)
f9xtkrgbimageload%sizex = sizex
f9xtkrgbimageload%sizey = sizey
do i=1,f90glcptr
   f9xtkrgbimageload%data(i:i) = char(data(i))
end do
end function f9xtkrgbimageload

subroutine f9xtkdrawstr(base,str)
integer(f90gluint) base
character(len=*) str
integer(f90gluint) int_str(len_trim(str))
integer i
int_str = (/ (ichar(str(i:i)),i=1,len_trim(str)) /)
call f9ytkdrawstr(base,int_str,len_trim(str))
end subroutine f9xtkdrawstr

end module f90gltk
